from sqlalchemy import Column, Integer, String, SmallInteger, Enum, DateTime, Text, Float, BigInteger
from sqlalchemy.ext.declarative import declarative_base

Base = declarative_base()


class s_CastleWarInfo(Base):
    __tablename__ = 's_CastleWarInfo'
    zone_idx = Column(SmallInteger, primary_key=True)
    open_wday = Column(SmallInteger)
    open_hour = Column(SmallInteger)
    open_min = Column(SmallInteger)
    close_hour = Column(SmallInteger)
    close_min = Column(SmallInteger)
    npc_idx = Column(SmallInteger)
    attacker_arrival_layer = Column(SmallInteger)
    defenser_arrival_layer = Column(SmallInteger)
    symbol_hench_idx = Column(SmallInteger)
    symbol_item_idx = Column(SmallInteger)


class s_ItemBox(Base):
    __tablename__ = 's_ItemBox'
    idx = Column(Integer, primary_key=True)
    add_idx = Column(Integer, primary_key=True)
    rate = Column(Float)
    count = Column(Integer)
    shuoming = Column(String)


class s_LvUserInfo(Base):
    __tablename__ = 's_LvUserInfo'
    Lv = Column(Integer, primary_key=True)
    LvUpExp = Column(BigInteger)


class s_mix(Base):
    __tablename__ = 's_mix'
    mode = Column(Integer)
    mainnum = Column(String, primary_key=True)
    maingrade = Column(Integer)
    subnum = Column(Integer, primary_key=True)
    subgrade = Column(Integer)
    result = Column(Integer, primary_key=True)


class s_mob(Base):
    __tablename__ = 's_mob'
    idx = Column(Integer, primary_key=True)
    zone_idx0 = Column(SmallInteger, default=0)
    zone_idx1 = Column(SmallInteger, default=0)
    zone_idx2 = Column(SmallInteger, default=0)
    zone_idx3 = Column(SmallInteger, default=0)
    zone_idx4 = Column(SmallInteger, default=0)
    zone_idx5 = Column(SmallInteger, default=0)
    birth_zone_layernum0 = Column(SmallInteger, default=0)
    birth_zone_layernum1 = Column(SmallInteger, default=0)
    birth_zone_layernum2 = Column(SmallInteger, default=0)
    birth_zone_layernum3 = Column(SmallInteger, default=0)
    birth_zone_layernum4 = Column(SmallInteger, default=0)
    birth_zone_layernum5 = Column(SmallInteger, default=0)
    move_type = Column(SmallInteger, default=0)
    monster_type = Column(SmallInteger)
    name = Column(String)
    agressive = Column(SmallInteger)
    sight_range = Column(SmallInteger, default=5)
    mobitem_idx = Column(SmallInteger, default=0)
    appear_rate0 = Column(SmallInteger, default=0)
    appear_rate1 = Column(SmallInteger, default=0)
    appear_rate2 = Column(SmallInteger, default=0)
    appear_rate3 = Column(SmallInteger, default=0)
    appear_rate4 = Column(SmallInteger, default=0)
    appear_rate5 = Column(SmallInteger, default=0)
    wait_time0 = Column(Integer, default=0)
    wait_time1 = Column(Integer, default=0)
    wait_time2 = Column(Integer, default=0)
    wait_time3 = Column(Integer, default=0)
    wait_time4 = Column(Integer, default=0)
    wait_time5 = Column(Integer, default=0)
    interval_time0 = Column(Integer, default=0)
    interval_time1 = Column(Integer, default=0)
    interval_time2 = Column(Integer, default=0)
    interval_time3 = Column(Integer, default=0)
    interval_time4 = Column(Integer, default=0)
    interval_time5 = Column(Integer, default=0)
    life_time0 = Column(Integer, default=0)
    life_time1 = Column(Integer, default=0)
    life_time2 = Column(Integer, default=0)
    life_time3 = Column(Integer, default=0)
    life_time4 = Column(Integer, default=0)
    life_time5 = Column(Integer, default=0)
    unable_attack_layer0 = Column(SmallInteger, default=0)
    unable_attack_layer1 = Column(SmallInteger, default=0)
    unable_attack_layer2 = Column(SmallInteger, default=0)
    unable_attack_layer3 = Column(SmallInteger, default=0)
    unable_attack_layer4 = Column(SmallInteger, default=0)
    unable_attack_layer5 = Column(SmallInteger, default=0)
    blocking_layer0 = Column(SmallInteger, default=0)
    blocking_layer1 = Column(SmallInteger, default=0)
    blocking_layer2 = Column(SmallInteger, default=0)
    blocking_layer3 = Column(SmallInteger, default=0)
    blocking_layer4 = Column(SmallInteger, default=0)
    blocking_layer5 = Column(SmallInteger, default=0)
    blocking_value0 = Column(SmallInteger, default=0)
    blocking_value1 = Column(SmallInteger, default=0)
    blocking_value2 = Column(SmallInteger, default=0)
    blocking_value3 = Column(SmallInteger, default=0)
    blocking_value4 = Column(SmallInteger, default=0)
    blocking_value5 = Column(SmallInteger, default=0)


class s_mobitem(Base):
    __tablename__ = 's_mobitem'
    idx = Column(Integer, primary_key=True)
    base_money = Column(Integer, default=0)
    bonus_money = Column(Integer, default=0)
    item_idx0 = Column(Integer, default=0)
    item_idx1 = Column(Integer, default=0)
    item_idx2 = Column(Integer, default=0)
    item_idx3 = Column(Integer, default=0)
    item_idx4 = Column(Integer, default=0)
    item_idx5 = Column(Integer, default=0)
    item_idx6 = Column(Integer, default=0)
    item_idx7 = Column(Integer, default=0)
    item_idx8 = Column(Integer, default=0)
    item_idx9 = Column(Integer, default=0)
    item_drop_percent0 = Column(Integer, default=0)
    item_drop_percent1 = Column(Integer, default=0)
    item_drop_percent2 = Column(Integer, default=0)
    item_drop_percent3 = Column(Integer, default=0)
    item_drop_percent4 = Column(Integer, default=0)
    item_drop_percent5 = Column(Integer, default=0)
    item_drop_percent6 = Column(Integer, default=0)
    item_drop_percent7 = Column(Integer, default=0)
    item_drop_percent8 = Column(Integer, default=0)
    item_drop_percent9 = Column(Integer, default=0)
    item_drop_count0 = Column(Integer, default=0)
    item_drop_count1 = Column(Integer, default=0)
    item_drop_count2 = Column(Integer, default=0)
    item_drop_count3 = Column(Integer, default=0)
    item_drop_count4 = Column(Integer, default=0)
    item_drop_count5 = Column(Integer, default=0)
    item_drop_count6 = Column(Integer, default=0)
    item_drop_count7 = Column(Integer, default=0)
    item_drop_count8 = Column(Integer, default=0)
    item_drop_count9 = Column(Integer, default=0)


class s_npc(Base):
    __tablename__ = 's_npc'
    idx = Column(Integer, primary_key=True)
    name = Column(String)
    type = Column(Integer, default=51)
    birth_zone_idx = Column(Integer, default=0)
    birth_zone_x = Column(Integer, default=0)
    birth_zone_y = Column(Integer, default=0)
    move_zone_layernum = Column(Integer, default=0)
    sell_type = Column(Integer, default=0)
    sell_ratio = Column(Integer, default=50)
    barter_item_idx = Column(Integer, default=0)


class s_npc_sale(Base):
    __tablename__ = 's_npc_sale'
    npc_idx = Column(Integer, primary_key=True)
    sale_type = Column(Integer, default=2)
    sale_idx = Column(Integer, primary_key=True)
    buy_ratio = Column(Integer, default=1000)


class s_Production(Base):
    __tablename__ = 's_Production'
    idx = Column(Integer, primary_key=True)
    doc_idx = Column(Integer)
    doc_name = Column(String)
    result_idx = Column(Integer)
    result_name = Column(String)
    result_count = Column(Integer)
    money = Column(Integer)
    default_pro = Column(Integer)
    add_pro = Column(Integer, default=0)
    opt_slot_cnt = Column(Integer, default=0)
    stuff_idx1 = Column(Integer)
    stuff_name1 = Column(String)
    stuff_count1 = Column(Integer)
    stuff_idx2 = Column(Integer, default=0)
    stuff_name2 = Column(String, default="0")
    stuff_count2 = Column(Integer, default=0)
    stuff_idx3 = Column(Integer, default=0)
    stuff_name3 = Column(String, default="0")
    stuff_count3 = Column(Integer, default=0)
    stuff_idx4 = Column(Integer, default=0)
    stuff_name4 = Column(String, default="0")
    stuff_count4 = Column(Integer, default=0)
    stuff_idx5 = Column(Integer, default=0)
    stuff_name5 = Column(String, default="0")
    stuff_count5 = Column(Integer, default=0)


class s_zone(Base):
    __tablename__ = 's_zone'
    idx = Column(SmallInteger, primary_key=True)
    name = Column(String)
    mob_able = Column(SmallInteger)
    revive_zone_layernum = Column(SmallInteger, default=254)
    nonPkZoneLayernum = Column(SmallInteger, default=0)
    dual_zone_layernum = Column(SmallInteger)
    min_mob = Column(SmallInteger)
    max_mob = Column(SmallInteger)
    mob_peruser = Column(SmallInteger, default=2)
    min_level = Column(SmallInteger, default=0)
    max_level = Column(SmallInteger)
    restriction = Column(Integer, default=4)
    item_idx = Column(SmallInteger, default=0)
    CollisionLayer = Column(SmallInteger, default=0)
    RootZone = Column(SmallInteger, default=0)
    Ability = Column(SmallInteger, default=0)
    mob_damage_rate = Column(Float, default=1.0)
    PkZoneFlag = Column(SmallInteger, default=0)
    dropitemidx = Column(SmallInteger, default=0)
    dropItemCond = Column(SmallInteger, default=0)


class s_item(Base):
    __tablename__ = 's_item'
    idx = Column(Integer, primary_key=True)
    name = Column(String)
    price = Column(Integer)
    barter_price = Column(SmallInteger)
    rarity = Column(SmallInteger)
    type = Column(SmallInteger)
    maxCnt = Column(SmallInteger)
    require_level = Column(SmallInteger)
    require_type = Column(SmallInteger)
    require_value = Column(SmallInteger)
    equip_type = Column(SmallInteger)
    equip_part0 = Column(SmallInteger)
    equip_part1 = Column(SmallInteger)
    equip_part2 = Column(SmallInteger)
    block_part0 = Column(SmallInteger)
    block_part1 = Column(SmallInteger)
    roll_spell_idx = Column(SmallInteger)
    roll_spell_level = Column(SmallInteger)
    ech_type0 = Column(SmallInteger)
    ech_type1 = Column(SmallInteger)
    ech_type2 = Column(SmallInteger)
    ech_type3 = Column(SmallInteger)
    ech_type4 = Column(SmallInteger)
    ech_type5 = Column(SmallInteger)
    ech_type6 = Column(SmallInteger)
    ech_typenum0 = Column(SmallInteger)
    ech_typenum1 = Column(SmallInteger)
    ech_typenum2 = Column(SmallInteger)
    ech_typenum3 = Column(SmallInteger)
    ech_typenum4 = Column(SmallInteger)
    ech_typenum5 = Column(SmallInteger)
    ech_typenum6 = Column(SmallInteger)
    ech_x0 = Column(SmallInteger)
    ech_x1 = Column(SmallInteger)
    ech_x2 = Column(SmallInteger)
    ech_x3 = Column(SmallInteger)
    ech_x4 = Column(SmallInteger)
    ech_x5 = Column(SmallInteger)
    ech_x6 = Column(SmallInteger)
    ech_speed_move = Column(SmallInteger)
    ech_speed_attack = Column(SmallInteger)
    ech_speed_skill = Column(SmallInteger)
    range = Column(SmallInteger)
    duration = Column(Integer)
    kind = Column(SmallInteger)
    rank = Column(SmallInteger)
    duration_type = Column(SmallInteger)
    restrict_type = Column(SmallInteger)
    make_synergy_type = Column(SmallInteger)
    make_synergy_level = Column(SmallInteger)


class s_monster(Base):
    __tablename__ = 's_monster'
    type = Column(Integer, primary_key=True)
    name = Column(String)
    race = Column(SmallInteger)
    start_base_level = Column(Integer)
    price = Column(Integer)
    sexratio = Column(SmallInteger)
    speed_move = Column(SmallInteger)
    speed_attack = Column(SmallInteger)
    hench_speed_attack = Column(SmallInteger)
    speed_skill = Column(SmallInteger)
    hench_speed_skill = Column(SmallInteger)
    core_rate = Column(Integer)
    stat_rate = Column(Float)
    HenchStatRate = Column(Float)
    loot_type = Column(SmallInteger)
    hp_rate = Column(Float)
    hench_hp_rate = Column(Float)
    exp_rate = Column(Float)
    attack_range = Column(SmallInteger)
    hench_attack_range = Column(SmallInteger)
    restrict_type = Column(SmallInteger)
    sp = Column(SmallInteger)
    skill = Column(SmallInteger)
    attack_range_x1 = Column(SmallInteger)
    attack_range_x2 = Column(SmallInteger)
    attack_range_y1 = Column(SmallInteger)
    attack_range_y2 = Column(SmallInteger)
    use_item_type = Column(SmallInteger)
    mix_restrict = Column(SmallInteger)
    duration = Column(Integer)
    duration_type = Column(SmallInteger)
